//////////////////////////////////////////////////////////////////////////////////////////
//	SHADOW_MAP_LIGHT.h
//	Class declaration for light with shadow map. Derives from INTERACTOR, so it can be moved
//	using the mouse
//	You may use this code however you wish, but if you do, please credit me and
//	provide a link to my website in a readme file or similar
//	Downloaded from: www.paulsprojects.net
//	Created:	20th July 2002
//////////////////////////////////////////////////////////////////////////////////////////	

#ifndef SHADOW_MAP_LIGHT_H
#define SHADOW_MAP_LIGHT_H

class SHADOW_MAP_LIGHT : public INTERACTOR
{
public:
	float n, f;
	MATRIX4X4 projectionMatrix;

	void SetClipDistances(float newNear, float newFar)
	{
		n=newNear;
		f=newFar;

		UpdateMatrices();
	}

	virtual void Update();
	void UpdateMatrices(void);
	void ShrinkFrustum(void);
	void GrowFrustum(void);
};

#endif	//SHADOW_MAP_LIGHT_H