//////////////////////////////////////////////////////////////////////////////////////////
//	EXT_blend_minmax_extension.cpp
//	EXT_blend_minmax extension setup
//	You may use this code however you wish, but if you do, please credit me and
//	provide a link to my website in a readme file or similar
//	Downloaded from: www.paulsprojects.net
//	Created:	20th July 2002
//////////////////////////////////////////////////////////////////////////////////////////	
#include <windows.h>
#include <GL\gl.h>
#include <GL\glext.h>
#include <GL\wglext.h>
#include "../LOG.h"
#include "EXT_blend_minmax_extension.h"

extern LOG errorLog;

bool EXT_blend_minmax_supported=false;

bool SetUpEXT_blend_minmax()
{
	//Check for support
	char * extensionString=(char *)glGetString(GL_EXTENSIONS);
	char * extensionName="GL_EXT_blend_minmax";

	char * endOfString;									//store pointer to end of string
	unsigned int distanceToSpace;						//distance to next space

	endOfString=extensionString+strlen(extensionString);

	//loop through string
	while(extensionString<endOfString)
	{
		//find distance to next space
		distanceToSpace=strcspn(extensionString, " ");

		//see if we have found extensionName
		if((strlen(extensionName)==distanceToSpace) &&
			(strncmp(extensionName, extensionString, distanceToSpace)==0))
		{
			EXT_blend_minmax_supported=true;
		}

		//if not, move on
		extensionString+=distanceToSpace+1;
	}
	
	if(!EXT_blend_minmax_supported)
	{
		errorLog.OutputError("EXT_blend_minmax unsupported!");
		return false;
	}

	errorLog.OutputSuccess("EXT_blend_minmax supported!");

	//get function pointers
	glBlendEquationEXT				=	(PFNGLBLENDEQUATIONEXTPROC)
										wglGetProcAddress("glBlendEquationEXT");

	return true;
}

//function pointers
PFNGLBLENDEQUATIONEXTPROC					glBlendEquationEXT					=NULL;

